package sillysagiri.scene;
import java.io.IOException;

import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.game.Sprite;

import sillysagiri.BMF;
import sillysagiri.Easing;
import sillysagiri.Scene;
import sillysagiri.Utils;

public class Intro extends Scene {
  private long counter = 0;
  private int state = 0;

  private BMF bmf_white;
  private BMF bmf_black;
  private BMF bmf_outline;
  private Image img_logo = null;
  private Image img_theworld = null;
  
  public void Preload() {
    try
    {
      bmf_white = BMF.Create("/silly/bmf/nds12_0.silly.gz", "/silly/bmf/nds12.fnt", 0xffffffff);
      bmf_outline = BMF.Create("/silly/bmf/onds12_0.silly.gz", "/silly/bmf/onds12.fnt", 0xffffffff);
      bmf_black = BMF.Create("/silly/bmf/nds12_0.silly.gz", "/silly/bmf/nds12.fnt", 0xff000000);
      img_logo = Image.createImage("/t_1.png");
    }
    catch(Exception e)
    {
      sagiri.Set_Scene(new DeathError(e));
    }
  }

  public void Destroy()
  {
    img_logo = null;
    img_theworld = null;
    bmf_white = null;
    bmf_black = null;
    bmf_outline = null;
  }

  public void Update(long dt, Graphics g)
  {
    counter += dt;
    
    switch (state) {
      case 0:
      {
        if (counter > 1800)
        {
          counter = 0;
          state = 1;
          break;
        }

        Utils.Clear_Screen(g, 73, 0, 0);

        int halfW = img_logo.getWidth()/2;
        int halfH = img_logo.getHeight()/2;
        float r = Easing.CubicEaseInOut((float)counter/1800);
        int pos = (int)Math.ceil(((Utils.GetScreenWidth()/2)+halfW) * r) - halfW;

        g.drawRegion(
          img_logo, 
          0, 0, img_logo.getWidth(), halfH, Sprite.TRANS_NONE, 
          pos, Utils.GetScreenHeight()/2, 
          Graphics.BOTTOM | Graphics.HCENTER);

        g.drawRegion(
          img_logo, 
          0, halfH, img_logo.getWidth(), img_logo.getHeight()-halfH, Sprite.TRANS_NONE, 
          Utils.GetScreenWidth() - pos, Utils.GetScreenHeight()/2, 
          Graphics.TOP | Graphics.HCENTER);
      }
      break;

      case 1:
      {
        if (counter > 500)
        {
          counter = 0;
          state = 2;

          try {
            img_logo = Image.createImage("/t_0.png");
            img_theworld = Image.createImage("/t_2.png");
          }
          catch(IOException e) 
          {
            sagiri.Set_Scene(new DeathError(e));
          }
        }
      }
      break;

      case 2:
      {
        Utils.Clear_Screen(g, 146, 36, 0);
        g.drawImage(
          img_logo, 
          Utils.GetScreenWidth()/2, Utils.GetScreenHeight()/2-35,
          Graphics.HCENTER | Graphics.VCENTER);
          
          g.drawImage(
            img_theworld,
          Utils.GetScreenWidth()/2, Utils.GetScreenHeight()/2,
          Graphics.HCENTER | Graphics.TOP);
          
          // TODO: fix utf-16 symbol
          bmf_black.DrawEx(g,
            "c Project .hack",
            5, Utils.GetScreenHeight()-5,
            Graphics.LEFT | Graphics.BOTTOM);

          bmf_white.Draw(g,
            "VOL 1 - v0.1-silly",
            5, 5);
          
          if (counter >= 600) counter = 0;
          if (counter < 400)
            bmf_outline.DrawEx(g, 
              "PRESS ANY KEY",
              Utils.GetScreenWidth()/2, (int)(Utils.GetScreenHeight()*0.7),
              Graphics.VCENTER | Graphics.HCENTER);

          if (sagiri.input.IsKeyDownAny())
            sagiri.Set_Scene(new MainMenu());
        }
      break;

      default: break;
    }
  }
}
